// 2016年12月26日
// 伊藤大智

#include <SPI.h>
#include <Ethernet.h>
#include <SoftwareSerial.h>


byte mac[] = {
  0x90, 0xA2, 0xDA, 0x0D, 0x86, 0xF3 // Ethernetシールド MAC ADRESS
};
IPAddress ip(192, 168, 0, 20); // IPアドレス
EthernetServer server(80); // ポート番号
SoftwareSerial mySerial(2, 3); // 2が受信(黄色に接続)、3が送信(青色に接続)


void setup(){
  Serial.begin(9600); // シリアルポートを9600 bps[ビット/秒]で初期化
  pinMode(2,INPUT);
  pinMode(3,OUTPUT);
  // SoftwareSerialのポートを設定
  mySerial.begin(4800);// ソフトウェアシリアルポートを4800 bps[ビット/秒]で初期化
  Ethernet.begin(mac, ip); // Ethernet初期化
  server.begin(); // サーバー開始
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP()); // 設定したIPアドレスを表示
}


void loop() {
  char mystr[80]="";
  char mybuf[80]="";
  char dmy[80]="";
  EthernetClient client = server.available();
  char in;
  String data,message,longitude_disp,latitude_disp;
  int longitude_deg,latitude_deg;
  float longitude_min,latitude_min;
  char URL[64];
  int hh,mm,ss; // 時刻
  int yy,mn,dd; // 日時
  char date[64];

  char data_char[80];
  float longitude,latitude;
  String a,n,e,time2,date2;
  int comma;

  if(TCP_gets(client,dmy,'\n')!=0){ // クライアントから何か文字が送られてくるまで待つ
    Serial.println("connecting.");
    Serial.println();
    client.println(", DATE(UTC) , TIME(UTC) , TIME(JST) ,  NS , LATITUDE(DEG) , LATITUDE(MIN) , EW , LONGITUDE(DEG) , LONGITUDE(MIN) ,  GOOGLE MAP URL");
    
    // 以下 GPSデータ処理スタート
    while(1){
      if(mySerial.available()){
        in = mySerial.read();
        data=data+in;
        
        if(in == '\r'){ // 改行コードを読んだら
          data=data+'\0';
//        Serial.print(data); // データ表示
          message=data.substring(4,7);
//        Serial.print(message);

          //RMCメッセージを受信した場合　データ処理開始
          if(message.equals("RMC")){

//          data="$GPRMC,083800.000,A,3539.9721,N,13947.5578,E,0.00,247.02,081116,,,A*67\0"; // デバッグ用　正しいデータ

            data.toCharArray(data_char,80); // String型をchar型に変換
//          Serial.println(data_char);
           
            comma=c_count(data_char,','); // カンマ数を数える
            if(comma==12){ // カンマ数が正常(12)だったら処理継続

              // 時刻、有効、経度、緯度、日付データをカンマ区切りで読み取り
              strtok(data_char,",");
              time2=strtok(NULL,",");
              a=strtok(NULL,",");
              latitude=atof(strtok(NULL,","));
              n=strtok(NULL,",");
              longitude=atof(strtok(NULL,","));
              e=strtok(NULL,",");
              strtok(NULL,",");
              strtok(NULL,",");
              date2=strtok(NULL,",");

 //           Serial.println(time2);
 //           Serial.println(a);
 //           Serial.println(longitude);
 //           Serial.println(n);
 //           Serial.println(latitude);
 //           Serial.println(e);
 //           Serial.println(date2);
 
              if(a.equals("A")){ // 15文字目がAだったらデータ有効

                // 時刻 日付情報を読み取る
                hh=(time2.substring(0,2)).toInt();
                mm=(time2.substring(2,4)).toInt();
                ss=(time2.substring(4,6)).toInt();
                dd=(date2.substring(0,2)).toInt();
                mn=(date2.substring(2,4)).toInt();
                yy=(date2.substring(4,6)).toInt();

                // 時刻 日付を表示(UTC)
                sprintf(date,"20%02d/%02d/%02d %02d:%02d:%02d (UTC)",yy,mn,dd,hh,mm,ss);
                Serial.println(date); // シリアルモニタに表示
                sprintf(mybuf,", 20%02d/%02d/%02d , %02d:%02d:%02d , ",yy,mn,dd,hh,mm,ss);
                client.print(mybuf); // クライアントに表示
                // JST(日本標準時間)を表示 日付は考慮しない
                JST(client,hh,mm,ss);

                // 緯度(latitude) 経度(longitude)情報を読み取る
                latitude_deg=latitude/100;
                latitude_min=latitude-latitude_deg*100;
                longitude_deg=longitude/100;
                longitude_min=longitude-longitude_deg*100;    

                // 緯度データ表示
                sprintf(mybuf,"latitude : %d degrees, ",latitude_deg); // シリアルモニタに表示
                Serial.print(mybuf); 
                Serial.print(latitude_min,4); // Arduino Unoのsprintf()では、%fを使うことができない
                Serial.print(" minutes, ");
                Serial.println(n);
                sprintf(mybuf," , %d , ",latitude_deg); // クライアントに表示
                client.print(n);
                client.print(mybuf);
                client.print(latitude_min,4);
                client.print(" , ");
                          
                // 経度データ表示
                sprintf(mybuf,"longitude : %d degrees, ",longitude_deg); // シリアルモニタに表示
                Serial.print(mybuf); 
                Serial.print(longitude_min,4); // Arduino Unoのsprintf()では、%fを使うことができない
                Serial.print(" minutes, ");
                Serial.println(e);
                sprintf(mybuf," , %d , ",longitude_deg); // クライアントに表示
                client.print(e);
                client.print(mybuf);
                client.print(longitude_min,4);
                client.print(" , ");
            
                // Google Map URL表示
                mapURL(client,latitude_deg,latitude_min,longitude_deg,longitude_min,n,e);
            
                }
              else{ // データ無効の場合
                Serial.println("NOT RECEIVED"); 
                client.println(",NOT RECEIVED");
                }
              Serial.println();
            }
            
            else{ // カンマの数が12ではなかった場合
              Serial.print("DATA INVALID Commas: "); 
              Serial.println(comma);
              client.print(",DATA INVALID Commas: ");
              client.println(comma);
              }
            }
            
          data=""; // データのリセット
          
          if (!client.connected()) {  // 接続解除されたら
            Serial.println("disconnecting.");
            Serial.println();
            client.stop();
            break;
          }
        }
      }
    }
  }
} 


// TCPを使い文字列を取得する関数
int TCP_gets(EthernetClient client,char *buf,char sw){
  int i=0;
  char c;
  if(client){
    while(client.connected()){
      if(client.available()){
        c=client.read();
        buf[i]=c;
        if(c==sw){ // 文字列の終わりなら終了
          break;
        }
        i++;
      }
    }
    buf[i]='\0'; // 終端文字挿入
    delay(1);
  }
  return i;
}


// 緯度,経度の値からGoogle MapのURLを表示する関数
void mapURL(EthernetClient client, int latitude_deg, float latitude_min, int longitude_deg, float longitude_min, String n, String e){
//  String longitude_min_str, latitude_min_str;
  int longitude_min_int;
  int latitude_min_int;  
  char URL[64];

  // 分(min)の60進法を10進法に変換
  longitude_min_int=longitude_min*10000/60;
  latitude_min_int=latitude_min*10000/60;

  if(n.equals("S")){ // 南半球だったら緯度座標を負にする
    latitude_deg*=-1;
  }
  if(e.equals("W")){ // 西半球だったら経度座標を負にする
    longitude_deg*=-1;
  }
  
  // Google Map URLを作成
  sprintf(URL,"http://maps.google.com/maps?q=%d.%d,%d.%d",latitude_deg,latitude_min_int,longitude_deg,longitude_min_int); // シリアルモニタに表示
  Serial.println(URL); // シリアルモニタにGoogle MAP URL表示
  client.println(URL); // クライアントにGoogle MAP URL表示
}


// UTC（協定世界時間）からJST(日本標準時間)に変換して表示(日付は考慮しない)
void JST(EthernetClient client,int hh,int mm,int ss){
  char date[64];
  hh=hh+9;
  if(hh>23){
    hh=hh-24;
  }
  sprintf(date,"           %02d:%02d:%02d (JST)",hh,mm,ss);
  Serial.println(date);
  sprintf(date,"%02d:%02d:%02d , ",hh,mm,ss);
  client.print(date);
}


// 文字列配列に含まれる特定の文字の数を数える関数
int c_count(char data[80], char target){
  int i=0;
  int count=0;
  while(data[i]!='\0'){
    if(data[i]==target){
      count++;
    }
    i++;
  }
  return count;
}

